package org.sazabi.util.bijection.netty

import com.twitter.bijection.{Bijection, Injection}

import java.nio.charset.Charset

import org.jboss.netty.buffer.{ChannelBuffer, ChannelBuffers}
import org.jboss.netty.util.CharsetUtil.UTF_8

import scala.util.control.Exception.allCatch

trait Injections {
  implicit val UTF8StringToChannelBuffer:
    Injection[String, ChannelBuffer] = StringToChannelBuffer(UTF_8)

  def StringToChannelBuffer(cs: Charset):
    Injection[String, ChannelBuffer] =
      Injection.build[String, ChannelBuffer](
        ChannelBuffers.copiedBuffer(_, cs))(allCatch opt _.toString(cs))
}

object injections extends Injections
